/**
 * Created by Sam R.
 * on 01-05-2011
 * at 20:23
 */
package com.cirrial.ld20 {
import org.flixel.FlxG;
import org.flixel.FlxSprite;
import org.flixel.FlxState;
import org.flixel.FlxText;

public class CutsceneState extends FlxState {
    [Embed(source = '../../../../data/graphics/intro1.png')]
    private var ImgIntro1:Class;
    [Embed(source = '../../../../data/graphics/intro2.png')]
    private var ImgIntro2:Class;
    [Embed(source = '../../../../data/graphics/intro3.png')]
    private var ImgIntro3:Class;

    [Embed(source = '../../../../data/graphics/outro1.png')]
    private var ImgOutro1:Class;
    [Embed(source = '../../../../data/graphics/outro2.png')]
    private var ImgOutro2:Class;

    private var introStrings:Array = [
            "It all began in a forgotten facility.",
            "One of its inhabitants was just waking up.",
            "intro1##They looked around and saw very little.",
            "intro2##But they found a robot much like themselves, with no legs.",
            "\"Are you going to leave the facility?\"",
            "\"It's dangerous to go alone! You should take me with you!\"",
            "The robot explained that it could stay perfectly, perfectly still and act as a platform.",
            "But this unfortunately meant it couldn't move on its own.",
            "intro3##So a team was made! And a facility was to be escaped!"
    ];

    private var outroStrings:Array = [
            "And so the two robots escaped.",
            "outro1##They ran faster than they ever had. Well, the one with legs did, anyway.",
            "\"Wow! It's so bright! I can barely see!\"",
            "outro2##And so the two robots looked out at the sunset over the ocean.",
            "Whatever happened now, one thing was for sure.",
            "It would be dangerous to go alone, so they'd set out together once more."
    ];

    private const GRAPHIC_WIDTH:Number = 200;
    private const GRAPHIC_HEIGHT:Number = 150;

    private var strings:Array;
    private var index:int = 0;

    private var display:FlxSprite;
    private var text:FlxText;

    private var acceptInput:Boolean = true;

    override public function create():void {
        if(PlayState.won) {
            strings = outroStrings;
        }
        else {
            strings = introStrings;
        }
        index = 0;

        display = new FlxSprite(Main.SCREEN_WIDTH/Main.ZOOM_LEVEL/2 - GRAPHIC_WIDTH/2, 20);
        display.visible = false;
        add(display);

        text = new FlxText(0, 180, Main.SCREEN_WIDTH/Main.ZOOM_LEVEL, strings[index]);
        text.setFormat("gameFont", 10, 0xFFFFFF, "center");
        add(text);

        var advanceText:FlxText = new FlxText(0, 230, Main.SCREEN_WIDTH/Main.ZOOM_LEVEL, "- Press Z to continue -");
        advanceText.setFormat("gameFont", 10, 0xFFFFFF, "center");
        add(advanceText);

        acceptInput = true;
    }

    override public function update():void {
        if(FlxG.keys.justPressed("Z") && acceptInput) {
            index += 1;
            if(index >= strings.length) {
                acceptInput = false;
                if(PlayState.won) FlxG.fade(0xFF000000, 0.5, goToWin);
                else FlxG.fade(0xFF000000, 0.5, goToPlay);
            } else {
                var string:String = strings[index];
                // check to see if we need to change to a thing
                var split:Array = string.split("##");
                if(split.length == 1) {
                    // no need to change the image
                    text.text = split[0];
                } else {
                    display.visible = true;
                    switch(split[0]) {
                        case "intro1":
                            display.loadGraphic(ImgIntro1);
                            break;
                        case "intro2":
                            display.loadGraphic(ImgIntro2);
                            break;
                        case "intro3":
                            display.loadGraphic(ImgIntro3);
                            break;
                        case "outro1":
                            display.loadGraphic(ImgOutro1);
                            break;
                        case "outro2":
                            display.loadGraphic(ImgOutro2);
                            break;
                    }
                    text.text = split[1];
                }
            }
        }
    }

    private function goToWin():void {
        FlxG.switchState(new WinState());
    }

    private function goToPlay():void {
        FlxG.switchState(new PlayState());
    }
}
}
